<?php
/**
 * Clase Base FN para BaseCrCreditoCuotaFN
 *
 * @package    
 * @subpackage BaseCrCreditoCuotaFN
 * @author     Willy
 * @version    SVN:: BaseCrCreditoCuotaFN.class.php,v 1.1 2013-01-04 11:11:51 william.taype Exp $
 */
class BaseCrCreditoCuotaFN extends CrCreditoCuotaBN
{
  private static $fieldNames = array (
    'Idcuota'=>'idcuota', 'Fechacuota'=>'fechacuota', 'Montototal'=>'montototal', 'Saldototal'=>'saldototal', 'Montocapital'=>'montocapital', 'Montointeres'=>'montointeres', 'Montomora'=>'montomora', 'Estado'=>'estado', 'Moneda'=>'moneda', 'Diasmora'=>'diasmora', 'Fechacreacion'=>'fechacreacion', 'Usuariocreacion'=>'usuariocreacion', 'Eliminado'=>'eliminado', 'Fechaeliminado'=>'fechaeliminado', 'Usuarioeliminado'=>'usuarioeliminado', 'Idcreditocrono'=>'idcreditocrono'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT idcuota, fechacuota, montototal, saldototal, montocapital, montointeres, montomora, estado, moneda, diasmora, fechacreacion, usuariocreacion, eliminado, fechaeliminado, usuarioeliminado, idcreditocrono FROM cr_credito_cuota WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT idcuota, fechacuota, montototal, saldototal, montocapital, montointeres, montomora, estado, moneda, diasmora, fechacreacion, usuariocreacion, eliminado, fechaeliminado, usuarioeliminado, idcreditocrono FROM cr_credito_cuota WHERE 1 ".$where;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdcuota()){ $where .= " AND idcuota = '".$this->getIdcuota()."'"; }
      if($this->getFechacuota()){ $where .= " AND fechacuota = '".$this->getFechacuota()."'"; }
      if($this->getMontototal()){ $where .= " AND montototal = '".$this->getMontototal()."'"; }
      if($this->getSaldototal()){ $where .= " AND saldototal = '".$this->getSaldototal()."'"; }
      if($this->getMontocapital()){ $where .= " AND montocapital = '".$this->getMontocapital()."'"; }
      if($this->getMontointeres()){ $where .= " AND montointeres = '".$this->getMontointeres()."'"; }
      if($this->getMontomora()){ $where .= " AND montomora = '".$this->getMontomora()."'"; }
      if($this->getEstado()){ $where .= " AND estado = '".$this->getEstado()."'"; }
      if($this->getMoneda()){ $where .= " AND moneda = '".$this->getMoneda()."'"; }
      if($this->getDiasmora()){ $where .= " AND diasmora = '".$this->getDiasmora()."'"; }
      if($this->getFechacreacion()){ $where .= " AND fechacreacion = '".$this->getFechacreacion()."'"; }
      if($this->getUsuariocreacion()){ $where .= " AND usuariocreacion = '".$this->getUsuariocreacion()."'"; }
      if($this->getEliminado()){ $where .= " AND eliminado = '".$this->getEliminado()."'"; }
      if($this->getFechaeliminado()){ $where .= " AND fechaeliminado = '".$this->getFechaeliminado()."'"; }
      if($this->getUsuarioeliminado()){ $where .= " AND usuarioeliminado = '".$this->getUsuarioeliminado()."'"; }
      if($this->getIdcreditocrono()){ $where .= " AND idcreditocrono = '".$this->getIdcreditocrono()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Búsqueda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idcuota, fechacuota, montototal, saldototal, montocapital, montointeres, montomora, estado, moneda, diasmora, fechacreacion, usuariocreacion, eliminado, fechaeliminado, usuarioeliminado, idcreditocrono FROM cr_credito_cuota WHERE 1 AND idcuota='".$this->getIdcuota()."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_db_query(Conexion::getNameDb(), $sql, $con);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con métodos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseCrCreditoCuotaFN = new BaseCrCreditoCuotaFN();
    $o_BaseCrCreditoCuotaFN->setIdcuota($o_propel->idcuota);
    $o_BaseCrCreditoCuotaFN->setFechacuota($o_propel->fechacuota);
    $o_BaseCrCreditoCuotaFN->setMontototal($o_propel->montototal);
    $o_BaseCrCreditoCuotaFN->setSaldototal($o_propel->saldototal);
    $o_BaseCrCreditoCuotaFN->setMontocapital($o_propel->montocapital);
    $o_BaseCrCreditoCuotaFN->setMontointeres($o_propel->montointeres);
    $o_BaseCrCreditoCuotaFN->setMontomora($o_propel->montomora);
    $o_BaseCrCreditoCuotaFN->setEstado($o_propel->estado);
    $o_BaseCrCreditoCuotaFN->setMoneda($o_propel->moneda);
    $o_BaseCrCreditoCuotaFN->setDiasmora($o_propel->diasmora);
    $o_BaseCrCreditoCuotaFN->setFechacreacion($o_propel->fechacreacion);
    $o_BaseCrCreditoCuotaFN->setUsuariocreacion($o_propel->usuariocreacion);
    $o_BaseCrCreditoCuotaFN->setEliminado($o_propel->eliminado);
    $o_BaseCrCreditoCuotaFN->setFechaeliminado($o_propel->fechaeliminado);
    $o_BaseCrCreditoCuotaFN->setUsuarioeliminado($o_propel->usuarioeliminado);
    $o_BaseCrCreditoCuotaFN->setIdcreditocrono($o_propel->idcreditocrono);
    return $o_BaseCrCreditoCuotaFN;
  }
}